	.module stalling.c
	.area data(ram, con, rel)
_SystemTicker::
	.blkb 4
	.area idata
	.word 0,0
	.area data(ram, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
	.dbsym e SystemTicker _SystemTicker L
_Motoristposition::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
	.dbsym e Motoristposition _Motoristposition I
_Motorsollposition::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
	.dbsym e Motorsollposition _Motorsollposition I
_Regelung::
	.blkb 1
	.area idata
	.byte 1
	.area data(ram, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
	.dbsym e Regelung _Regelung c
_Fehler::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
	.dbsym e Fehler _Fehler c
_Kommando::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
	.dbsym e Kommando _Kommando c
_Wert::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
	.dbsym e Wert _Wert c
	.area vector(rom, abs)
	.org 2
	rjmp _int0_isr
	.area data(ram, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
	.area text(rom, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
	.dbfunc e int0_isr _int0_isr fV
	.even
_int0_isr::
	st -y,R24
	st -y,R25
	in R24,0x3f
	st -y,R24
	.dbline -1
	.dbline 69
; /*********************************************
;  *
;  * Project : Stalling controller
;  * Date    : 24.02.2003
;  *
;  * Chip type           : AT90S2313
;  * Clock frequency     : 1,842300 MHz
;  * Memory model        : Tiny
;  * Internal SRAM size  : 128
;  * External SRAM size  : 0
;  * Data Stack size     : 32
; *********************************************/
; 
; #include <io2313v.h>
; #include <macros.h>
; #include <stdlib.h>
; #include <string.h>
; 
; // PI-Reglerkonstanten
; #define P_Daempfung_Z 15 						// Dmpfung des P-Reglers Zhler
; #define Aus 0
; #define Ein 1
; 
; // Anzahl Systemticks, bis ein Timeoutfehler generiert wird
; #define Motortimeout 1000
; 
; // Bits im Fehlerregister
; #define Fehler_Nullposition 1		
; #define Fehler_Positionierung 2
; 
; #define Schrittumrechnung 5 		// Umrechnung (1-9) in absolute Motorposition
; 
; #define Kommando_stellen 'W'        // Anstellwinkel ndern
; #define Kommando_Fehler  'F'		// Fehlerzustand abfragen
; #define Kommando_Null    'N'		// Referenz anfahren
; #define Kommando_aus     'A'		// Regelung aus
; #define Kommando_ein     'E'		// Regelung ein
; 
; // Systemzeit
; long SystemTicker = 0;				// Systemuhr
; 
; // Motorpositionen
; int Motoristposition = 0;			// Aktuelle Position des Motors
; int Motorsollposition = 0;			// Sollposition des Motors
; 
; // PI-Regler
; char Regelgroesse;					// Wert der Ausgangs-PWM
; long Stellgroesse;                  // Errechnete Stellgre
; char Regelung = Ein;				// Position ausregeln oder nicht ?
; 
; // Fehlerergister
; char Fehler = 0;                	// Fehlerregister
; 
; // Kommandos
; char Kommando=0;         			// Empfangenes Kommando
; char Wert = 0;                      // Emfangener Parameter
; 
; // Rckgabepuffer fr INT -> ASCII-Wandlung
; char outpbuf [9];
; 
; /*****************************************
;  *
;  * External Interrupt 0 service routine
;  * berwacht den Winkelenkoder des Motors
;  *
;  *****************************************/
; #pragma interrupt_handler int0_isr:2
;  void int0_isr (void)
;  {
	.dbline 71
	sbis 0x10,3
	rjmp L2
	.dbline 71
	lds R24,_Motoristposition
	lds R25,_Motoristposition+1
	adiw R24,1
	sts _Motoristposition+1,R25
	sts _Motoristposition,R24
	rjmp L3
L2:
	.dbline 71
	lds R24,_Motoristposition
	lds R25,_Motoristposition+1
	sbiw R24,1
	sts _Motoristposition+1,R25
	sts _Motoristposition,R24
L3:
	.dbline -2
	.dbline 72
;   // Aktuelle Position des Winkelenkoders festhalten
;   if (PIND & 8) Motoristposition++; else Motoristposition--;
;  }
L1:
	ld R24,y+
	out 0x3f,R24
	ld R25,y+
	ld R24,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 12
	rjmp _timer0_ovf_isr
	.area text(rom, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
	.dbfunc e timer0_ovf_isr _timer0_ovf_isr fV
	.even
_timer0_ovf_isr::
	rcall push_lset
	rcall push_gset2
	.dbline -1
	.dbline 86
; 
; /*********************************************
;  *
;  * Timer 0 overflow interrupt service routine
;  * MAcht die PI-Regelung. Evtl. Zahlenbereiche
;  * korrigieren auf int ?
;  *
;  * Aufruf ca. jede ms bei 2 Mhz
;  * Laufzeit 500us
;  *
;  *********************************************/
; #pragma interrupt_handler timer0_ovf_isr:7
; void timer0_ovf_isr (void)
;  {
	.dbline 87
;   SystemTicker++;					// Systemuhr erhhen
	lds R22,_SystemTicker+2
	lds R23,_SystemTicker+2+1
	lds R20,_SystemTicker
	lds R21,_SystemTicker+1
	subi R20,255  ; offset = 1
	sbci R21,255
	sbci R22,255
	sbci R23,255
	sts _SystemTicker+1,R21
	sts _SystemTicker,R20
	sts _SystemTicker+2+1,R23
	sts _SystemTicker+2,R22
	.dbline 90
;   
;     // P-Anteil bestimmen
;     Stellgroesse = ( (Motorsollposition - Motoristposition) * P_Daempfung_Z ); 
	lds R2,_Motoristposition
	lds R3,_Motoristposition+1
	lds R18,_Motorsollposition
	lds R19,_Motorsollposition+1
	sub R18,R2
	sbc R19,R3
	ldi R16,15
	ldi R17,0
	rcall mpy16s
	mov R2,R16
	mov R3,R17
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	sts _Stellgroesse+1,R3
	sts _Stellgroesse,R2
	sts _Stellgroesse+2+1,R5
	sts _Stellgroesse+2,R4
	.dbline 93
;   
;     // Umrechnen in Ganzzahligen Wert
;     if ( abs (Stellgroesse) > 255 ) Regelgroesse = 255; else 
	lds R16,_Stellgroesse
	lds R17,_Stellgroesse+1
	rcall _abs
	ldi R24,255
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brge L5
	.dbline 93
	sts _Regelgroesse,R24
	rjmp L6
L5:
	.dbline 94
;                                     Regelgroesse = abs (Stellgroesse);
	lds R16,_Stellgroesse
	lds R17,_Stellgroesse+1
	rcall _abs
	sts _Regelgroesse,R16
L6:
	.dbline 97
;   
;     // Motor ansteuern, Drehrichtung festlegen               
;     if (Stellgroesse < 0) PORTB &= ~16; else 
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	lds R4,_Stellgroesse+2
	lds R5,_Stellgroesse+2+1
	lds R2,_Stellgroesse
	lds R3,_Stellgroesse+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brge L7
	.dbline 97
	cbi 0x18,4
	rjmp L8
L7:
	.dbline 98
;                           PORTB |= 16;	
	sbi 0x18,4
L8:
	.dbline 101
	lds R2,_Regelung
	tst R2
	breq L9
	.dbline 101
	lds R2,_Regelgroesse
	out 0x2a,R2
	rjmp L10
L9:
	.dbline 101
	clr R2
	out 0x2a,R2
L10:
	.dbline -2
	.dbline 103
;    
;     // PWM steuern 
; 	if (Regelung) OCR1L = Regelgroesse; else OCR1L = 0; 
; 
;  }
L4:
	rcall pop_gset2
	rcall pop_lset
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e boot _boot fV
	.even
_boot::
	.dbline -1
	.dbline 111
; 
; /******************
;  *
;  * System init
;  *
;  ******************/
; void boot (void)
;  {
	.dbline 112
;   CLI ();          // disable all interrupts
	cli
	.dbline 118
;  
;   // Input/Output Ports initialization
;   // Port B initialization
;   // Func0=Out Func1=In Func2=In Func3=Out Func4=Out Func5=In Func6=In Func7=In
;   // State0=1 State1=T State2=T State3=1 State4=1 State5=T State6=T State7=T
;   PORTB=0x19;
	ldi R24,25
	out 0x18,R24
	.dbline 119
;   DDRB=0x19;
	out 0x17,R24
	.dbline 124
; 
;   // Port D initialization
;   // Func0=In Func1=In Func2=In Func3=In Func4=Out Func5=In Func6=In
;   // State0=T State1=T State2=T State3=T State4=1 State5=T State6=T
;   PORTD=0x10;
	ldi R24,16
	out 0x12,R24
	.dbline 125
;   DDRD=0x10;
	out 0x11,R24
	.dbline 130
; 
;   // Timer/Counter 0 initialization
;   // Clock source: System Clock
;   // Clock value: 1842,300 kHz
;   TCCR0=0x02;
	ldi R24,2
	out 0x33,R24
	.dbline 131
;   TCNT0=0x00;
	clr R2
	out 0x32,R2
	.dbline 140
; 
;   // Timer/Counter 1 initialization
;   // Clock source: System Clock
;   // Clock value: 1842,300 kHz
;   // Mode: Ph. correct PWM top=00FFh
;   // OC1 output: Inverted
;   // Noise Canceler: Off
;   // Input Capture on Falling Edge
;    TCCR1A=0xC1;
	ldi R24,193
	out 0x2f,R24
	.dbline 141
;   TCCR1B=0x01;
	ldi R24,1
	out 0x2e,R24
	.dbline 142
;   TCNT1H=0x00;
	out 0x2d,R2
	.dbline 143
;   TCNT1L=0x00;
	out 0x2c,R2
	.dbline 144
;   OCR1H=0x00;
	out 0x2b,R2
	.dbline 145
;   OCR1L=0x00;					                          // PWM-Startwert, entspricht 0%
	out 0x2a,R2
	.dbline 152
;   
;   // UART initialization
;   // Communication Parameters: 8 Data, 1 Stop, No Parity
;   // UART Receiver: On
;   // UART Transmitter: On
;   // UART Baud rate: 9600 / 2 Mhz
;   UCR=0x18;
	ldi R24,24
	out 0xa,R24
	.dbline 153
;   UBRR=12;
	ldi R24,12
	out 0x9,R24
	.dbline 159
; 
;   // External Interrupt(s) initialization
;   // INT0: On
;   // INT0 Mode: Rising Edge
;   // INT1: Off
;   MCUCR = 0x03;
	ldi R24,3
	out 0x35,R24
	.dbline 160
;   GIMSK = 0x40;
	ldi R24,64
	out 0x3b,R24
	.dbline 161
;   TIMSK = 0x02;
	ldi R24,2
	out 0x39,R24
	.dbline 163
; 
;   SEI ();          	   	   				 	   	  		  // re-enable interrupts
	sei
	.dbline -2
	.dbline 165
; 
;  }
L11:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ReceiveByte _ReceiveByte fc
	.even
_ReceiveByte::
	.dbline -1
	.dbline 173
; 
; /**************************************************
;  *
;  * Liefert ein evtl. empfangenes Zeichen, sonst 0
;  *
;  **************************************************/
; char ReceiveByte ()
;  {
	.dbline 174
;   if (!(USR & 0x80)) return (0);
	sbic 0xb,7
	rjmp L13
	.dbline 174
	clr R16
	rjmp L12
L13:
	.dbline 175
;   return (UDR);
	in R16,0xc
	.dbline -2
L12:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SendByte _SendByte fV
;        zeichen -> R16
	.even
_SendByte::
	.dbline -1
	.dbline 184
;  }
; 
; /**************************************************
;  *
;  * Sendet ein Byte
;  *
;  **************************************************/
; void SendByte (char zeichen)
;  {
	.dbline 186
;   // TXC auf Null setzen durch berschreiben mit 1
;   USR |= 64;
	sbi 0xb,6
	.dbline 189
;     
;   // Slaveadresse senden
;   UDR = zeichen;
	out 0xc,R16
L16:
	.dbline 192
L17:
	.dbline 192
;   
;   // Warten bis Zeichen gesendet 
;   while (!(USR & 64));
	sbis 0xb,6
	rjmp L16
	.dbline -2
	.dbline 193
;  }
L15:
	.dbline 0 ; func end
	ret
	.dbsym r zeichen 16 c
	.dbend
	.dbfunc e PutString _PutString fV
;              s -> R20,R21
	.even
_PutString::
	rcall push_gset1
	mov R20,R16
	mov R21,R17
	.dbline -1
	.dbline 264
; 
; /***************************************************************************************************************
;  *
;  * Integer nach String umwandeln
;  *
;  ***************************************************************************************************************/
; /*
; char* inttostr (int twert)
;  {
;    unsigned short ad,rest;
;    char step;
;    int wert;
;    
;    wert = twert;
; 
;    memset (outpbuf, 0, 9);	                    // Buffer lschen
;    step=0;
;    
;    if (wert < 0)
;     {
; 	 outpbuf [0]='-';
; 	 step++;
; 	 wert *= -1;
; 	}  
; 	
;    rest = wert;
; 
;    if (wert >=10000)	                        // Stellen nacheinander abfragen+zuordnen
;    	{
;    	 ad=(rest / 10000);
;    	 outpbuf [step] = (48+ad);                    // 48 entspricht '0'
;    	 rest=rest-(10000*ad);
;    	 step++;
;    	}
;    if (wert >=1000)
;    	{
;      ad=(rest / 1000);
;    	 outpbuf[step]=(ad+48);
;    	 rest=rest-(1000*ad);
;    	 step++;
;    	}
;    	if (wert >=100)
;    	{
;    	 ad=(rest / 100);
;    	 outpbuf[step]=ad+48;
;    	 rest=rest-(100*ad);
;    	 step++;
;    	}
; 
;    	if (wert >=10)
;    	{
;    	 ad=(rest / 10);
;    	 outpbuf[step]=ad+48;
;    	 rest=rest-(10*ad);
;    	 step++;
;    	}
;    	
; 	outpbuf[step]=(48+rest);
;    	outpbuf [step+1]=0;                        // mit Null abschlieen !!
;    	step++;
;    	return (outpbuf);
;  }
; */
;  
; /**************************************************************************************************************
;  *
;  * String auf Schnittstelle ausgeben
;  *
;  **************************************************************************************************************/
; void PutString (const char * s)
;  {
	rjmp L21
L20:
	.dbline 265
	mov R2,R20
	mov R3,R21
	subi R20,255  ; offset = 1
	sbci R21,255
	mov R30,R2
	mov R31,R3
	lpm
	mov R16,R0
	rcall _SendByte
L21:
	.dbline 265
;   while(*s) SendByte (*s++);
	mov R30,R20
	mov R31,R21
	lpm
	tst R0
	brne L20
	.dbline -2
	.dbline 266
;  }
L19:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r s 20 pc
	.dbend
	.dbfunc e SucheNull _SucheNull fV
	.even
_SucheNull::
	rcall push_gset2
	.dbline -1
	.dbline 292
;  
; /**************************************************************************************************************
;  *
;  * Nummer auf Schnittstelle ausgeben
;  *
;  **************************************************************************************************************/
; /*
; void PutNum (void)
;  {
;   char z = 0;
;   
;   while (outpbuf [z] != 0)
;    {
;     SendByte (outpbuf [z]);
;     z++;
;    }
;  }
; */
; 
; /***************************************
;  *
;  * Fhrt den Motor in die Nullposition
;  *
;  **************************************/
; void SucheNull (void)
;  {
	.dbline 294
;   // Befindet sich der Motor in der Nullposition ? Dann rausfahren
;   if (!(PIND & 64))
	sbic 0x10,6
	rjmp L24
	.dbline 295
;    {
	.dbline 296
;      SystemTicker=0;					
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _SystemTicker+1,R21
	sts _SystemTicker,R20
	sts _SystemTicker+2+1,R23
	sts _SystemTicker+2,R22
	.dbline 297
;      Motorsollposition = 50;
	ldi R24,50
	ldi R25,0
	sts _Motorsollposition+1,R25
	sts _Motorsollposition,R24
L26:
	.dbline 298
L27:
	.dbline 298
; 	 while ( (SystemTicker < Motortimeout) && (Motorsollposition != Motoristposition) );
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	lds R4,_SystemTicker+2
	lds R5,_SystemTicker+2+1
	lds R2,_SystemTicker
	lds R3,_SystemTicker+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brge L29
	lds R2,_Motoristposition
	lds R3,_Motoristposition+1
	lds R4,_Motorsollposition
	lds R5,_Motorsollposition+1
	cp R4,R2
	cpc R5,R3
	brne L26
L29:
	.dbline 299
; 	 if (!(PIND & 64)) Fehler |= Fehler_Nullposition;					  	  // Bit 0 im Fehlerregister setzen
	sbic 0x10,6
	rjmp L30
	.dbline 299
	lds R24,_Fehler
	ori R24,1
	sts _Fehler,R24
L30:
	.dbline 300
;    }
L24:
	.dbline 303
;    
;   // Nullposition anfahren
;   SystemTicker=0;					
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _SystemTicker+1,R21
	sts _SystemTicker,R20
	sts _SystemTicker+2+1,R23
	sts _SystemTicker+2,R22
	.dbline 304
;   Motorsollposition = -500;
	ldi R24,-500
	ldi R25,-2
	sts _Motorsollposition+1,R25
	sts _Motorsollposition,R24
	rjmp L33
L32:
	.dbline 307
;   while ( (Motorsollposition != 0) && (SystemTicker < Motortimeout) )
;    // Ist die Ruheposition erreicht ? Dann Motor abschalten durch Setzen der Positionen
;    if (!(PIND & 64))
	sbic 0x10,6
	rjmp L35
	.dbline 308
;     {
	.dbline 309
;      Motorsollposition = 0;
	clr R2
	clr R3
	sts _Motorsollposition+1,R3
	sts _Motorsollposition,R2
	.dbline 310
;      Motoristposition = 0;
	sts _Motoristposition+1,R3
	sts _Motoristposition,R2
	.dbline 311
; 	 OCR1L = 0;      		        					// Motor aus
	out 0x2a,R2
	.dbline 312
;     }
L35:
L33:
	.dbline 305
	lds R2,_Motorsollposition
	lds R3,_Motorsollposition+1
	tst R2
	brne X0
	tst R3
	breq L37
X0:
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	lds R4,_SystemTicker+2
	lds R5,_SystemTicker+2+1
	lds R2,_SystemTicker
	lds R3,_SystemTicker+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlt L32
L37:
	.dbline 315
;   
;   // Timeout aufgetreten ?
;   if (SystemTicker >= Motortimeout)
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	lds R4,_SystemTicker+2
	lds R5,_SystemTicker+2+1
	lds R2,_SystemTicker
	lds R3,_SystemTicker+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlt L38
	.dbline 316
;    {               
	.dbline 317
;     Motorsollposition=0;
	clr R2
	clr R3
	sts _Motorsollposition+1,R3
	sts _Motorsollposition,R2
	.dbline 318
;     Motoristposition=0;
	sts _Motoristposition+1,R3
	sts _Motoristposition,R2
	.dbline 319
;     OCR1L = 0;      		        					// Motor aus
	out 0x2a,R2
	.dbline 320
;     Fehler |= Fehler_Nullposition;					  	  // Bit 0 im Fehlerregister setzen
	lds R24,_Fehler
	ori R24,1
	sts _Fehler,R24
	.dbline 321
;    } 
L38:
	.dbline 324
; 
;  // Position 100 anfahren. Dort greift die Druckplatte
;   SystemTicker=0;					
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _SystemTicker+1,R21
	sts _SystemTicker,R20
	sts _SystemTicker+2+1,R23
	sts _SystemTicker+2,R22
	.dbline 325
;   Motorsollposition = 100;
	ldi R24,100
	ldi R25,0
	sts _Motorsollposition+1,R25
	sts _Motorsollposition,R24
L40:
	.dbline 326
L41:
	.dbline 326
;   while ( (Motoristposition != 100) && (SystemTicker < Motortimeout) );
	lds R24,_Motoristposition
	lds R25,_Motoristposition+1
	cpi R24,100
	ldi R30,0
	cpc R25,R30
	breq L43
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	lds R4,_SystemTicker+2
	lds R5,_SystemTicker+2+1
	lds R2,_SystemTicker
	lds R3,_SystemTicker+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlt L40
L43:
	.dbline 328
	clr R2
	clr R3
	sts _Motorsollposition+1,R3
	sts _Motorsollposition,R2
	.dbline 329
	sts _Motoristposition+1,R3
	sts _Motoristposition,R2
	.dbline 330
	out 0x2a,R2
	.dbline 333
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	lds R4,_SystemTicker+2
	lds R5,_SystemTicker+2+1
	lds R2,_SystemTicker
	lds R3,_SystemTicker+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlt L44
	.dbline 333
	lds R24,_Fehler
	ori R24,1
	sts _Fehler,R24
L44:
	.dbline -2
	.dbline 334
; 
;   Motorsollposition = 0;
;   Motoristposition = 0;
;   OCR1L = 0;      		        					// Motor aus
; 
;   // Timeout aufgetreten ?
;   if (SystemTicker >= Motortimeout) Fehler |= Fehler_Nullposition;					  	  // Bit 0 im Fehlerregister setzen
;  } 
L23:
	rcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fV
	.even
_main::
	.dbline -1
	.dbline 342
;  
; /******************
;  *
;  * Main
;  *
;  ******************/
; void main (void)
;  {
	.dbline 344
;   
;   boot (); 			 		// System init
	rcall _boot
	.dbline 346
;   
;   PutString ("Start");	    // Startmeldung ausgeben
	ldi R16,<L47
	ldi R17,>L47
	rcall _PutString
	rjmp L49
L48:
	.dbline 350
;  
;   // Hauptschleife
;   while (1)
;    { 
	.dbline 352
;      // Entgegennehmen von Kommandos
;      Kommando = ReceiveByte ();
	rcall _ReceiveByte
	sts _Kommando,R16
	.dbline 353
;      if (Kommando != 0)
	mov R2,R16
	tst R16
	brne X2
	rjmp L51
X2:
	.dbline 354
;       {          
	.dbline 356
;        // Gltiges Kommando wurde empfangen
;        if (Kommando == Kommando_stellen)
	mov R24,R2
	cpi R24,87
	breq X3
	rjmp L53
X3:
	.dbline 357
;         {
	.dbline 358
;          outpbuf [0] = 0;
	clr R2
	sts _outpbuf,R2
	rjmp L56
L55:
	.dbline 359
	rcall _ReceiveByte
	sts _outpbuf,R16
L56:
	.dbline 359
;          while (outpbuf [0] == 0) outpbuf [0] = ReceiveByte (); 
	lds R2,_outpbuf
	tst R2
	breq L55
	.dbline 360
;          outpbuf [1] = 0;
	clr R2
	sts _outpbuf+1,R2
	rjmp L60
L59:
	.dbline 361
	rcall _ReceiveByte
	sts _outpbuf+1,R16
L60:
	.dbline 361
;          while (outpbuf [1] == 0) outpbuf [1] = ReceiveByte (); 
	lds R2,_outpbuf+1
	tst R2
	breq L59
	.dbline 364
; 		 
; 		 // Der Wert (1-9) enthlt jetzt den Anstellwinkel und mu umgerchnet werden in Motorschritte
;          Motorsollposition =  (long)(((outpbuf [0]-48)*10) + (outpbuf [1]-48)) * Schrittumrechnung;
	lds R18,_outpbuf
	clr R19
	ldi R16,10
	ldi R17,0
	rcall mpy16s
	mov R24,R16
	mov R25,R17
	subi R24,224
	sbci R25,1
	lds R30,_outpbuf+1
	clr R31
	sbiw R30,48
	add R24,R30
	adc R25,R31
	mov R2,R24
	mov R3,R25
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldi R20,5
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	mov R16,R20
	mov R17,R21
	mov R18,R22
	mov R19,R23
	rcall mpy32s
	sts _Motorsollposition+1,R17
	sts _Motorsollposition,R16
	.dbline 376
; 		 
; 		  // Ergebniss anzeigen
; /*
; 		  inttostr (Motorsollposition);
; 		  PutNum ();
; 		  PutString (":");
; 		  inttostr (Motoristposition);
; 		  PutNum ();
; 		  PutString (" # ");
; */		 
; 		 // Warten, bis diese Position erreicht wurde, oder ein Timeout auftritt
; 		 SystemTicker=0;					
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _SystemTicker+1,R21
	sts _SystemTicker,R20
	sts _SystemTicker+2+1,R23
	sts _SystemTicker+2,R22
L65:
	.dbline 377
L66:
	.dbline 377
;   		 while ( (Motorsollposition != Motoristposition) && (SystemTicker < Motortimeout) );
	lds R2,_Motoristposition
	lds R3,_Motoristposition+1
	lds R4,_Motorsollposition
	lds R5,_Motorsollposition+1
	cp R4,R2
	cpc R5,R3
	breq L68
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	lds R4,_SystemTicker+2
	lds R5,_SystemTicker+2+1
	lds R2,_SystemTicker
	lds R3,_SystemTicker+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlt L65
L68:
	.dbline 380
;   
;   	     // Timeout aufgetreten ?
;   		 if (SystemTicker >= Motortimeout)
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	lds R4,_SystemTicker+2
	lds R5,_SystemTicker+2+1
	lds R2,_SystemTicker
	lds R3,_SystemTicker+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlt L69
	.dbline 381
;    		  {               
	.dbline 382
;     	   Motorsollposition=0;
	clr R2
	clr R3
	sts _Motorsollposition+1,R3
	sts _Motorsollposition,R2
	.dbline 383
;     	   Motoristposition=0;
	sts _Motoristposition+1,R3
	sts _Motoristposition,R2
	.dbline 384
;     	   Fehler |= Fehler_Positionierung;					  	  // Bit 1 im Fehlerregister setzen
	lds R24,_Fehler
	ori R24,2
	sts _Fehler,R24
	.dbline 385
;    		  }
L69:
	.dbline 388
; 
; 		  // Ergebniss anzeigen
; 		  SendByte (Fehler+48);
	lds R16,_Fehler
	subi R16,208    ; addi 48
	rcall _SendByte
	.dbline 400
; /*
; 		  inttostr (Motorsollposition);
; 		  PutNum ();
; 		  PutString (":");
; 		  inttostr (Motoristposition);
; 		  PutNum ();
; 		  outpbuf [0]=10;
; 		  outpbuf [1]=13;
; 		  outpbuf [2]=0;
; 		  PutNum ();
; */		  
;         } // Von if (Kommando == Kommando_stellen)
L53:
	.dbline 403
;      
;        // Gltiges Kommando wurde empfangen
;        if (Kommando == Kommando_Fehler) SendByte (Fehler+48);
	lds R24,_Kommando
	cpi R24,70
	brne L71
	.dbline 403
	lds R16,_Fehler
	subi R16,208    ; addi 48
	rcall _SendByte
L71:
	.dbline 406
;  
;        // Gltiges Kommando wurde empfangen
;        if (Kommando ==  Kommando_Null) 
	lds R24,_Kommando
	cpi R24,78
	brne L73
	.dbline 407
; 	    {
	.dbline 408
; 		 Fehler = 0;
	clr R2
	sts _Fehler,R2
	.dbline 409
;          SucheNull (); 
	rcall _SucheNull
	.dbline 410
; 		 SendByte (Fehler+48);
	lds R16,_Fehler
	subi R16,208    ; addi 48
	rcall _SendByte
	.dbline 411
; 		} 
L73:
	.dbline 414
; 
;        // Gltiges Kommando wurde empfangen
;        if (Kommando ==  Kommando_aus) 
	lds R24,_Kommando
	cpi R24,65
	brne L75
	.dbline 415
; 	    {
	.dbline 416
; 		 PORTB &= ~1;
	cbi 0x18,0
	.dbline 417
; 		 Regelung = Aus;
	clr R2
	sts _Regelung,R2
	.dbline 418
; 		 SendByte ('A');
	ldi R16,65
	rcall _SendByte
	.dbline 419
; 		} 
L75:
	.dbline 422
; 
; 		       // Gltiges Kommando wurde empfangen
;        if (Kommando ==  Kommando_ein) 
	lds R24,_Kommando
	cpi R24,69
	brne L77
	.dbline 423
; 	    {
	.dbline 424
; 		 Regelung = Ein;
	ldi R24,1
	sts _Regelung,R24
	.dbline 425
; 		 PORTB |= 1;
	sbi 0x18,0
	.dbline 426
; 		 SendByte ('E');
	ldi R16,69
	rcall _SendByte
	.dbline 427
; 		} 
L77:
	.dbline 429
; 
;       } // Von  if (Kommando != 0)
L51:
	.dbline 431
L49:
	.dbline 349
	rjmp L48
X1:
	.dbline -2
	.dbline 433
;         
;    }
; 
;  }
L46:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\TEMP\Stalling\stalling.c
_outpbuf::
	.blkb 9
	.dbsym e outpbuf _outpbuf A[9:9]c
_Stellgroesse::
	.blkb 4
	.dbsym e Stellgroesse _Stellgroesse L
_Regelgroesse::
	.blkb 1
	.dbsym e Regelgroesse _Regelgroesse c
	.area lit(rom, con, rel)
L47:
	.byte 'S,'t,'a,'r,'t,0
